/*
   A Program to Convert Wordstar files to HTML format. 

            v. 3, Apr 13, 1999

    syntax is: WS_HTM src dst

              where src, dst are filespecs
  ----------------------------------------------------------------
             environment: MS-DOS, using MIX Power C compiler
             (superset of Microsoft C, Borland Turbo C), however,
             should be extremely portable.
  -----------------------------------------------------------------
             This program is in the public domain, and may be 
             used for any purpose whatsover, without permission 
             or notification, but it is offered "as-is" without 
             any warrentee, express or implied.
  -----------------------------------------------------------------

   To convert Wordstar 3/4 to HTML. I suggest you use Wordstar's 
   internal filters to convert Wordstar 5 and subsequent to Wordstar 4, 
   then use my program to go the rest of the way. 
   
                                   Andrew D. Todd
                                   1249 Pineview Dr., Apt 4
                                   Morgantown, WV 26505

                                   U46A8@WVNVM.WVNET.EDU


*/
#include <stdio.h>
#include <io.h>
#include <fcntl.h>
#include <sys\types.h>
#include <sys\stat.h>



main(int argc, char *argv[])
{
  int status, f_in, f_out;
  char e_string[80];

pass these through to parse-buffer
  char input_buffer[10000000];
  int index_to_buffer;

  
  /*get the file names*/
  if( argc < 3 )
  {
    printf(" \nBoth Source and Destination Files Needed\n");
    _exit(3);
  }
  f_in = open(argv[1], O_RDONLY|O_BINARY);
  if(f_in == -1) 
  {
    printf(" \n%s Does Not Exist\n", argv[1]);
    _exit(4);
  }
  f_out = open(argv[2], O_WRONLY|O_CREAT|O_EXCL|O_BINARY, S_IREAD|S_IWRITE);
  if( f_out == -1) 
  {
    strcpy(&e_string, " \nDestination File ");
    strcat(&e_string,  argv[2]);
    strcat(&e_string, " Invalid\n");
    perror(&e_string);
    _exit(5);
  }
  get_path_of(titles_file_spec, argv[1])
  strcat(titles_file, ¨titles.PF¨  
/*
  open it  and find out if there is an entry
   if so, import the title, and insert it in the aproporiate place
*/ 
  /*create a header */  
  put_line(f_out, "<HTML>");
  put_line(f_out, "<HEAD>");
  put_line(f_out, "</HEAD>");
  put_line(f_out, "<BODY>");

  /* read thefile into a buffer */
  status = read(f_in, &c, 1);
  if(status != 1) break;
  else 
    /*leave 80K vacant up front */
    parse_buffer(input_bufer, SIZEOF(input_buffer, ,int is_recursion_allowed);  
  /* now add the tail and close*/
  put_line(f_out, "</BODY>");
  put_line(f_out, "</HTML>");
  close(f_in);
  close(f_out);
  _exit(0);
}


/*--------------------------------------------------------*/
parse_buffer( int f_out, 
              unsigned char input_bufer[], 
              int size_of_buffer, 
              int start_point_offset,
              int number_of_bytes
            )
{
  char curr_c, c_s, next_c, c_after_next;
  
  int curr_column;

  int index_to_buffer;

  manage_flip_flop_char_attr(f_out, curr_c, ¨initialize¨);
 
  curr_column = 0;

  /*and now do the conversion */
  for(
       index_to_buffer=start_point_offset;
       index_to_buffer <= start_point_offset+number_of_bytes ;
       index_to_buffer++
      )            
    /* 
       Do over number_of_bytes from Start_point_offset, 
        but additional material may be patched in at the front,
          and used up,  
            which is why there is an offset.
    */
  {
    curr_c=input_bufer[index_to_buffer];
    c_s = curr_c & '\x7f';
    next_c=input_bufer[index_to_buffer+1];
    c_after_next=input_bufer[index_to_buffer+2];
/*case 1*/
    /*disambiguate periods*/
    if(curr_c == ¨.¨)
    {
       if(curr_column == 0)          /* if it is a dot command*/
       {
          write_s(f_out, ¨WORDSTAR DOT COMMAND: ¨);
          curr_column = 1;
       }
       else                         /*if itis only a period*/
       {
         send_char_to_html(f_out, curr_c); 
         curr_column++;
       }
    }
    /*
      WordStar ¨dot-commands¨ are user visible, 
            and are fully described in the user manual.
    */
/*case 2*/
    else if( isprint(curr_c))               /*PRINTABLE*/
    {
       send_char_to_html(f_out, curr_c);  
       curr_column++;
    }
/*case 3*/
    else if( isprint(c_s))              /* PRINTABLE WITH HIGH BIT */
    {
       send_char_to_html(f_out, c_s); 
       curr_column++;
    }
/*case 4*/
    else if( curr_c == '\r')            /*Cntrl-M HARD CARRIAGE RETURN*/
    {
      write_s(f_out, "\r\n<P>");
      if(next_c == ´\n´) index_to_buffer++;
      curr_column = 0;
      manage_flip_flop_char_attr(f_out, curr_c, ¨reset¨);
            /*  makes the assumption that special
                                  attributes dont persist across a 
                                  paragraph break */
    } 
/*case 5*/
    else if( curr_curr_c == '\x8d')     /*SOFT CARRIAGE RETURN*/
    {
         write_s(f_out, "\r\n"); 
         if(next_c == \n) index_to_buffer++;
    }
/*case 6*/
    else if( curr_c == '\0c')            /*Cntrl-L-- Page Break*/
    {
      write_s(f_out, "\r\n<P>");
      if(next_c == \n) index_to_buffer++;
      curr_column = 0;
      manage_flip_flop_char_attr(f_out, curr_c, ¨reset¨);
            /*  makes the assumption that special
                                  attributes dont persist across a 
                                  page break */
    } 

/*case 7*/
    /*
       In Wordstar, a number of Cntrl-bytes toggle the print 
        attribute of text. IN HTML, the attributes have different tags
         to turn them off and on. So we have to keep track of the 
           state of the Wordstar document, 
            and select the appropriate HTML tag. 
    */
    else if( 
               (curr_c == '\x02' /* Cntrl-B Bold */)
            ||
               (curr_c == '\x04' /* Cntrl-D Double */) 
            || 
               (curr_c == '\x0b' /* Cntrl-K Indexed */)   
            || 
               (curr_c == '\x13' /* Cntrl-S Underline */)  
            ||  
               (curr_c == '\x14' /* Cntrl-T SuperScript */) 
            ||   
               (curr_c == '\x16' /* Cntrl-V Subscript */) 
            ||   
               (curr_c == '\x18' /* Cntrl-X Strikeout */)  
            ||  
               (curr_c == '\x19' /* Cntrl-Y Italics */)
           ) manage_flip_flop_char_attr(f_out, curr_c, ¨toggle¨);

/*
   case 8
     if it is an extended character, 
       that is: [hex 1b][ext_char][hex 1c]
*/
    else if( curr_c == ´\x1b´)
    {
      if(c_after_next == ´\x1c´)
      {
        send_ext_char_to_html(f_out, next_c);
        index_to_buffer+=2;
      }
      else write_hex_code(f_out, ´\x1b´);
    }
/*
   case 9
     Crntl-H Overprint
     A common ad-hoc method of forming extended characters
*/
   else if( curr_c == '\x08');
          write_s(
                   f_out, 
                   ¨[Overprint]¨
                  );
/*
  case 10
    Cntrl-I Tab
    PROBLEM
*/
   else if( curr_c == '\x09')
        write_s(f_out, ¨[TAB]¨);
/*
   case 11
     Unpaired Line Feed
*/
   else if( curr_c == '\x0a')
        write_s(f_out, ¨<P>[LINE FEED]<P>¨);

/* case 12
   Custom Print Controls-- 
   only decodable by reference to printer manual 
     and dot-X commands, wordstar configration settings
*/
   else if( curr_c == '\x05')  
          write_s(
                   f_out, 
                   ¨<P>/r/n[Cntrl-E -- Custom Print Control]/r/n<P>¨
                  );
   else if( curr_c == '\x11')  
          write_s(
                   f_out, 
                   ¨<P>/r/n[Cntrl-Q -- Custom Print Control]/r/n<P>¨
                  );
   else if( curr_c == '\x12' )  
          write_s(
                   f_out, 
                   ¨<P>/r/n[Cntrl-R -- Custom Print Control]/r/n<P>¨
                 );
   else if( curr_c == '\x17')  
          write_s(
                  f_out, 
                  ¨<P>/r/n[Cntrl-W -- Custom Print Control]/r/n<P>¨
                 );
/*case 13  Reserved Characters*/
   else if( curr_c == '\x10')  
            write_s(
                    f_out, 
                    ¨<P>/r/n[Cntrl-P -- Reserved Char]/r/n<P>¨
                   );
   else if( curr_c == '\x15')  
           write_s(
                    f_out, 
                    ¨<P>/r/n[Cntrl-U -- Reserved Char]/r/n<P>¨
                  );

/*
   case 14
   Cntrl-At-- Obsolete--fix Print Position
*/
   else if( curr_c == '\x00')   
           write_s(
                    f_out, 
                    ¨[Cntrl-At -- fix Print Position ]/r/n<P>¨
                  );
/* case 15
   old font change mechnism, 
    superseded by symetric sequence 15h, 
      and should have been automatically striped out 
        if edited under version 5 and subsequent
*/
   else if( curr_c == '\x01')  
           write_s(
                    f_out, 
                    ¨<P>/r/n[Cntrl-A -- Altrenative Font]/r/n<P>¨
                  );
   else if( curr_c == '\x0e') 
            write_s(
                    f_out, 
                    ¨<P>/r/n[Cntrl-N -- Return to Normal Font]/r/n<P>¨
                  );
/*
   case 16
             Cntrl-C -- Obsolete-- 
                Pause For User Response During Print.
                 In other words, the user was expected to look at 
                   what the printer had printed off, 
                    insert a special daisywheel print element 
                      or change a printer ribbon, 
                      and resume. 
*/
   else if( curr_c == '\x03') 
          write_s(
                    f_out, 
                    ¨<P>/r/n[Cntrl-C -- Meaning Unrecoverable]/r/n<P>¨
                  );
/* case 17
   Daisywheel Phantom characters
   Meaningful only if you know which daisywheel was being used.
*/
   else if( curr_c == '\x06' /* Cntrl-F */)  
           write_s(
                    f_out, 
                    ¨[Daisywheel Phantom Space]>¨
                  );
   else if( curr_c == '\x07' /* Cntrl-G */)  
          write_s(
                    f_out, 
                    ¨[Daisywheel Phantom Rubout]¨
                  );
/*case 18*/
   else if( curr_c == '\x0f' /* Cntrl-O -- Binding space*/)  
           ;

/*
   case 19
       Cntrl-Z -- End of File used as padding at the end 
         of the file to bring it up to a round length 
           under C/PM and MS-DOS v.1. Print bytecode if there is only one
*/
   else if( curr_c == '\x1a')
   {
     if(
         (next_c != '\x1a')
        &&
         /*and not end of buffer*/
       )
         write_s(f_out, ¨[hex code 1a]¨);
   }; 

/*  REWORK THIS, TO KNOW IF IT IS CLOSE ENOUGH TO THE END TO BE A PAD */
/*
   case 20
   Symetric Sequences
   FIX
*/
   else if( curr_c == '\x1d' /* Cntrl-Right-Bracket -- */)  
           index_to_buffer=
              parse_symetric_sequence(
                         f_out, input_bufer. index_to_buffer);
/*
   case 21
   Soft Hyphen
*/
   else if( curr_c == '\x1e' /* Cntrl-Caret -- */)  
           ;
   else if( curr_c == '\x1f' /* Cntrl-Under_Hyphen -- */)
/*
   case 22
   Any Other Byte
    put out the hex code and let the user figure out what it means
*/
   else  write_hex_code(f_out, curr_c);
  }
}
/*------------------------------------------------------------------*/

    /*
       In Wordstar, a number of Cntrl-bytes toggle the print 
        attribute of text. IN HTML, the attributes have different tags
         to turn them off and on. So we have to keep track of the 
           state of the Wordstar document, 
            and select the appropriate HTML tag. 
    */

manage_flip_flop_char_attr(int f_out, char curr_c, char *mode )
{

  int static is_attr[8];

  int i;

  /* define the names of the text state counters */
  int bold_attr = 0;
  int doub_attr = 1;
  int undl_attr = 2;
  int sup_attr = 3;
  int sub_attr = 4;
  int ital_attr = 5;
  int strikeout_attr = 6;
  int indexed_attr =7;
  
  if (strcmp(mode, ¨toggle¨) == 0)
  {
    if( curr_c == '\x02' /*Cntrl-B*/)  
         flip_attr(&is_attr, bold_attr, f_out, "<B>", "</B>", ¨toggle¨);
    else if( curr_c == '\x04' /*Cntrl-D*/)  
         flip_attr(&is_attr, doub_attr, f_out, "<B>", "</B>", ¨toggle¨);
    else if( curr_c == '\x0b' /*Cntrl-D*/)  
         flip_attr(&is_attr, indexed_attr, f_out, "<?>", "</?>", ¨toggle¨);
    else if( curr_c == '\x13' /*Cntrl-S*/)  
         flip_attr(&is_attr, undl_attr, f_out, "<U>", "</U>", ¨toggle¨);
    else if( curr_c == '\x14' /*Cntrl-T*/)  
         flip_attr(&is_attr, sup_attr, f_out, "<SUP>", "</SUB>", ¨toggle¨);
    else if( curr_c == '\x16' /*Cntrl-V*/)  
         flip_attr(&is_attr, sub_attr, f_out, "<SUB>", "</SUB>", ¨toggle¨);
    else if( curr_c == '\x18' /*Cntrl-X*/)  
         flip_attr(&is_attr, 
                          strikeout_attr, f_out, "<S>", "</S>", ¨toggle¨);
    else if( curr_c == '\x19' /*Cntrl-Y*/)  
         flip_attr(&is_attr, ital_attr, f_out, "<EM>", "</EM>", ¨toggle¨);
  }
  else if(strcmp(mode,¨initialize¨ ) == 0)
  {
    int i;
    for(i=0;i < 8; i++)
    {
      is_attr[i] = 0;
    }
  } 
  else if(strcmp(mode,¨reset¨ ) == 0)
  {
    flip_attr(&is_attr, bold_attr, f_out, "<B>", "</B>", ¨reset¨);     
    flip_attr(&is_attr, doub_attr, f_out, "<B>", "</B>", ¨reset¨);
    flip_attr(&is_attr, indexed_attr, f_out, "<?>", "</?>", ¨reset¨);
    flip_attr(&is_attr, undl_attr, f_out, "<U>", "</U>", ¨reset¨);
    flip_attr(&is_attr, sup_attr, f_out, "<SUP>", "</SUB>", ¨reset¨);
    flip_attr(&is_attr, sub_attr, f_out, "<SUB>", "</SUB>", ¨reset¨);
    flip_attr(&is_attr, strikeout_attr, f_out, "<S>", "</S>", ¨reset¨);
    flip_attr(&is_attr, ital_attr, f_out, "<EM>", "</EM>", ¨reset¨);
  }
}
/*------------------------------------------------------------------*/
flip_attr(int *is_attr, int this_attr, int f_out, char *beg_str, char *end_str, char *mode)    
{
  if(is_attr[this_attr])
  {
    is_attr[this_attr] = 0;
    write_s(f_out, end_str);
  }
  else if(strcmp(mode, ¨reset¨) == 0)
  {
    is_attr[this_attr] = 1;
    write_s(f_out, beg_str);
  }
}
/* rewrite to localize this as far as possible. a;; the main program needs to know is that the following characters are flip attributes, and that something appropiate is being put in the output stream. there are three possible cases, initialize, reset, and encounter a bytecode*/

/*------------------------------------------------------------------*/
write_hex_code(int f_out, char c)
{
  char c1, c2, c1c, c2c;
  char[16] char_rep= ¨[hex code bb]¨;
  c2=c%16;   /*modulo off the high order nybble*/
  c1=(c-c2)/16; /* and subtract to obtain the remainder*/
  if(c1 <= 9) c1c = c1 + '0';
       else c1c = c1 + 'A'-10;
  if(c2 <= 9) c2c = c2 + '0';
       else c2c = c2 + 'A'-10;
   char_rep[11] = c1c;
   char_rep[12] =c2c;
   write_s(f_out, &char_rep);
}
/*------------------------------------------------------------------*/
send_char_to_html(int f_out, char c)
{
 char send_str[2];
 if(c == "\"") write_s(f_out, "&quot;");
 else if(c == "&") write_s(f_out, "&amp;");
 else if(c == "<") write_s(f_out, "&lt;");
 else if(c == ">") write_s(f_out, "&gt;");
 else
 {
   send_str[0] = c;
   send_str[1] = '\0';
   write_s(f_out, &send_str);
 }
}
/*provides aliasing for source characters which are reserved in HTML*/
/*------------------------------------------------------------------*/
put_line(int f_out, char *line_str)
{
  write_s(f_out, line_str); 
  write_s(f_out, "\r\n");
}
/*------------------------------------------------------------------*/
write_s(int f_out, char *s)
{
  write(f_out, s, strlen(s));
}
/* the general output point*/
/*------------------------------------------------------------------*/
send_ext_char_to_html(int f_out, char c)
{
  switch(c)
  {
   case ´\x00´: write_s(f_out, ¨ ¨); break;/*blank*/
   case ´\x01´: write_s(f_out, ¨[happy_face]¨); break;/*happy face*/
   case ´\x02´: write_s(f_out, ¨[inv_happy_face]¨); break;
                                             /*inverse happy face*/
   case ´\x03´: write_s(f_out, ¨&heartsuit;¨); break;/*heart*/
   case ´\x04´: write_s(f_out, ¨&diamondsuit;¨); break;/*diamond*/
   case ´\x05´: write_s(f_out, ¨&clubsuit;¨); break;/*club*/
   case ´\x06´: write_s(f_out, ¨&spadesuit;¨); break;/*spade*/
   case ´\x07´: write_s(f_out, ¨&bullet;¨); break;/*bullet*/
   case ´\x08´: write_s(f_out, ¨[inv_bullet]¨); break;/*inverse bullet*/
   case ´\x09´: write_s(f_out, ¨&xcirc;¨); break;/*circle*/
   case ´\x0a´: write_s(f_out, ¨[inv_circle]¨); break;/*inverse circl*/
   case ´\x0b´: write_s(f_out, ¨&male;¨); break;/*male sign*/
   case ´\x0c´: write_s(f_out, ¨&female;¨); break;/*female sign*/
   case ´\x0d´: write_s(f_out, ¨&sung;¨); break;/*single note*/
   case ´\x0e´: write_s(f_out, ¨&sung;&sung;¨); break;/*double note*/
   case ´\x0f´: write_s(f_out, ¨[sun]¨); break;/*sun*/

   case ´\x10´: write_s(f_out, ¨&rtrif;¨); break;/*right triangle*/
   case ´\x11´: write_s(f_out, ¨&ltrif;¨); break;/*left triangle*/
   case ´\x12´: write_s(f_out, ¨&updownarrow;¨); break;/*up-down arrow*/
   case ´\x13´: write_s(f_out, ¨!!¨); break;/*double exclamation*/
   case ´\x14´: write_s(f_out, ¨&para;¨); break;/*paragraph sign*/
   case ´\x15´: write_s(f_out, ¨&sect;¨); break;/*section sign*/
   case ´\x16´: write_s(f_out, ¨&hybull;¨); break;/*rectangular bullet*/
   case ´\x17´: write_s(f_out, ¨&UpArrowBar;&DownArrowBar;¨); break;
                                                    /*up/down to line*/
   case ´\x18´: write_s(f_out, ¨&uparrow;¨); break;/*up arrow*/
   case ´\x19´: write_s(f_out, ¨&downarrow;¨); break;/*down arrow*/
   case ´\x1a´: write_s(f_out, ¨&rightarrow;¨); break;/*right arrow*/
   case ´\x1b´: write_s(f_out, ¨&leftarrow;¨); break;/*left arrow*/
   case ´\x1c´: write_s(f_out, ¨&boxur;¨); break;/*lower left box*/
   case ´\x1d´: write_s(f_out, ¨&leftrightarrow;¨); break;
                                              /*left-right arrow*/
   case ´\x1e´: write_s(f_out, ¨&blacktriangle;¨); break;/*up triangle*/
   case ´\x1f´: write_s(f_out, ¨&blacktriangledown;¨); break;
                                            /*down triangle*/


   case ´\x80´: write_s(f_out, ¨&Ccedil;¨); break;
   case ´\x81´: write_s(f_out, ¨&uuml;¨); break;
   case ´\x82´: write_s(f_out, ¨&eacute;¨); break;
   case ´\x83´: write_s(f_out, ¨&acirc;¨); break;
   case ´\x84´: write_s(f_out, ¨&auml;¨); break;
   case ´\x85´: write_s(f_out, ¨&agrave;¨); break;
   case ´\x86´: write_s(f_out, ¨&aring;¨); break;
   case ´\x87´: write_s(f_out, ¨&ccedil;¨); break;

   case ´\x88´: write_s(f_out, ¨&ecirc;¨); break;
   case ´\x89´: write_s(f_out, ¨&euml;¨); break;
   case ´\x8a´: write_s(f_out, ¨&egrave;¨); break;
   case ´\x8b´: write_s(f_out, ¨&iuml;¨); break;
   case ´\x8c´: write_s(f_out, ¨&icirc;¨); break;
   case ´\x8d´: write_s(f_out, ¨&igrave;¨); break;
   case ´\x8e´: write_s(f_out, ¨&Auml;¨); break;
   case ´\x8f´: write_s(f_out, ¨&Aring;¨); break;

   case ´\x90´: write_s(f_out, ¨&Eacute;¨); break;
   case ´\x91´: write_s(f_out, ¨&aelig;¨); break;
   case ´\x92´: write_s(f_out, ¨&AElig;¨); break;


   case ´\x93´: write_s(f_out, ¨&ocirc;¨); break;
   case ´\x94´: write_s(f_out, ¨&ouml;¨); break;
   case ´\x95´: write_s(f_out, ¨&ograve;¨); break;
   case ´\x96´: write_s(f_out, ¨&ucirc;¨); break;
   case ´\x97´: write_s(f_out, ¨&ugrave;¨); break;
   case ´\x98´: write_s(f_out, ¨&yuml;¨); break;
   case ´\x99´: write_s(f_out, ¨&Ouml;¨); break;
   case ´\x9a´: write_s(f_out, ¨&Uuml;¨); break;

   case ´\x9b´: write_s(f_out, ¨&cent;¨); break; 
   case ´\x9c´: write_s(f_out, ¨&pound;¨); break;
   case ´\x9d´: write_s(f_out, ¨&yen;¨); break;
   case ´\x9e´: write_s(f_out, ¨[Pt]¨); break;/*Pt sign*/

   case ´\x9f´: write_s(f_out, ¨[funct]¨); break;/*the function mark*/

   case ´\xa0´: write_s(f_out, ¨&aacute;¨); break;
   case ´\xa1´: write_s(f_out, ¨&iacute;¨); break;
   case ´\xa2´: write_s(f_out, ¨&oacute;¨); break;
   case ´\xa3´: write_s(f_out, ¨&uacute;¨); break;
   case ´\xa4´: write_s(f_out, ¨&ntilde;¨); break;
   case ´\xa5´: write_s(f_out, ¨&Ntilde;¨); break;
   case ´\xa6´: write_s(f_out, ¨&amacr;¨); break;
   case ´\xa7´: write_s(f_out, ¨&omacr;¨); break;

   case ´\xa8´: write_s(f_out, ¨&iquest;¨); break;
   case ´\xa9´: write_s(f_out, ¨&boxdr;¨); break; /*upper left box*/
   case ´\xaa´: write_s(f_out, ¨&boxdl;¨); break;/*upper right box*/
   case ´\xab´: write_s(f_out, ¨&frac12;¨); break;
   case ´\xac´: write_s(f_out, ¨&frac14;¨); break;
   case ´\xad´: write_s(f_out, ¨!¨); break;/*opening exclamation point*/
   case ´\xae´: write_s(f_out, ¨&laquo;¨); break;/*<< mark*/
   case ´\xaf´: write_s(f_out, ¨&raquo;¨); break;/*>> mark*/
   case ´\xb0´: write_s(f_out, ¨&blk14;¨); break;/*light block*/
   case ´\xb1´: write_s(f_out, ¨&blk12;¨); break;/*medium block*/
   case ´\xb2´: write_s(f_out, ¨&blk34;¨); break;/*dark block*/

   case ´\xb3´: write_s(f_out, ¨&boxv;¨); break;/*single vertical*/
   case ´\xb4´: write_s(f_out, ¨&boxvl;¨); break;/*single right juntion*/
   case ´\xb5´: write_s(f_out, ¨&boxvL;¨); break;/*2 to 1 right junction*/
   case ´\xb6´: write_s(f_out, ¨&boxVl;¨); break;/*1 to 2 right junction*/
   case ´\xb7´: write_s(f_out, ¨&boxDl;¨); break;/*1 to 2 upper right*/
   case ´\xb8´: write_s(f_out, ¨&boxdL;¨); break;/*2 to 1 upper right*/
   case ´\xb9´: write_s(f_out, ¨&boxVL;¨); break;/*double right junction*/
   case ´\xba´: write_s(f_out, ¨&boxV;¨); break;/*double vertical*/
   case ´\xbb´: write_s(f_out, ¨&boxDL;¨); break;/*double upper right*/
   case ´\xbc´: write_s(f_out, ¨&boxUL;¨); break;/*double lower right*/
   case ´\xbd´: write_s(f_out, ¨&boxUl;¨); break;/*1 to 2 lower right*/
   case ´\xbe´: write_s(f_out, ¨&boxuL;¨); break;/*2 to 1 lower right*/
   case ´\xbf´: write_s(f_out, ¨&boxdl;¨); break;/*single upper right*/
   case ´\xc0´: write_s(f_out, ¨&boxur;¨); break;/*single lower left*/
   case ´\xc1´: write_s(f_out, ¨&boxhu;¨); break;/*single lower junction*/
   case ´\xc2´: write_s(f_out, ¨&boxhd;¨); break;/*single upper junction*/
   case ´\xc3´: write_s(f_out, ¨&boxvr;¨); break;/*single left junction*/
   case ´\xc4´: write_s(f_out, ¨&boxh;¨); break;/*single horiontal*/
   case ´\xc5´: write_s(f_out, ¨&boxvh;¨); break;/*single intersection*/
   case ´\xc6´: write_s(f_out, ¨&boxvR;¨); break;/*2 to 1 left junction*/
   case ´\xc7´: write_s(f_out, ¨&boxVr;¨); break;/*1 to 2 left junction*/
   case ´\xc8´: write_s(f_out, ¨&boxUR;¨); break;/*double lower left*/
   case ´\xc9´: write_s(f_out, ¨&boxDR;¨); break;/*double upper left*/
   case ´\xca´: write_s(f_out, ¨&boxHU;¨); break;/*double lower junction*/
   case ´\xcb´: write_s(f_out, ¨&boxHD;¨); break;/*double upper junction*/
   case ´\xcc´: write_s(f_out, ¨&boxVR;¨); break;/*double left junction*/
   case ´\xcd´: write_s(f_out, ¨&boxH;¨); break;/*double horizontal*/
   case ´\xce´: write_s(f_out, ¨&boxVH;¨); break;/*double intersection*/
   case ´\xcf´: write_s(f_out, ¨&boxHu;¨); break;/*1 to 2 lower junction*/
   case ´\xd0´: write_s(f_out, ¨&boxhU;¨); break;/*2 to 1 lower junction*/
   case ´\xd1´: write_s(f_out, ¨&boxHd;¨); break;/*1 to 2 upper junction*/
   case ´\xd2´: write_s(f_out, ¨&boxhD;¨); break;/*2 to 1 upper junction*/
   case ´\xd3´: write_s(f_out, ¨&boxUr;¨); break;/*1 to 2 lower left*/
   case ´\xd4´: write_s(f_out, ¨&boxuR;¨); break;/*2 to 1 lower left*/
   case ´\xd5´: write_s(f_out, ¨&boxdR;¨); break;/*2 to 1 upper left*/
   case ´\xd6´: write_s(f_out, ¨&boxDr;¨); break;/*1 to 2 upper left*/
   case ´\xd7´: write_s(f_out, ¨&boxVh;¨); break;/*2 to 1 intersection*/
   case ´\xd8´: write_s(f_out, ¨&boxvH;¨); break;/*1 to 2 intersection*/
   case ´\xd9´: write_s(f_out, ¨&boxul;¨); break;/*single lower right*/
   case ´\xda´: write_s(f_out, ¨&boxdr;¨); break;/*single upper left*/

   case ´\xdb´: write_s(f_out, ¨&block;¨); break;/*inverse space*/
   case ´\xdc´: write_s(f_out, ¨&lhblk;¨); break;/*lower inverse*/
   case ´\xdd´: write_s(f_out, ¨&marker;¨); break;/*left inverse*/
   case ´\xde´: write_s(f_out, ¨&marker;¨); break;/*right inverse*/
   case ´\xdf´: write_s(f_out, ¨&uhblk;¨); break;/*upper inverse*/

   case ´\xe0´: write_s(f_out, ¨&alpha;¨); break;
   case ´\xe1´: write_s(f_out, ¨&beta;¨); break;
   case ´\xe2´: write_s(f_out, ¨&Gamma;¨); break;
   case ´\xe3´: write_s(f_out, ¨&pi;¨); break;
   case ´\xe4´: write_s(f_out, ¨&Sigma;¨); break;
   case ´\xe5´: write_s(f_out, ¨&sigma;¨); break;
   case ´\xe6´: write_s(f_out, ¨&mu;¨); break;
   case ´\xe7´: write_s(f_out, ¨&tau;¨); break;
   case ´\xe8´: write_s(f_out, ¨&Phi;¨); break;
   case ´\xe9´: write_s(f_out, ¨&Theta;¨); break;
   case ´\xea´: write_s(f_out, ¨&Omega;¨); break;
   case ´\xeb´: write_s(f_out, ¨&delta;¨); break;
   case ´\xec´: write_s(f_out, ¨[infinity]¨); break;/*infinity*/
   case ´\xed´: write_s(f_out, ¨&straightphi;¨); break;
   case ´\xee´: write_s(f_out, ¨&epsilon;¨); break;

   case ´\xef´: write_s(f_out, ¨&Intersection;¨); break; 
                                                /*intersection of sets*/
   case ´\xf0´: write_s(f_out, ¨&Congruent;¨); break; /*is identical to*/
   case ´\xf1´: write_s(f_out, ¨&PlusMinus;¨); break;
   case ´\xf2´: write_s(f_out, ¨&ge;¨); break;/*greater than or equal*/
   case ´\xf3´: write_s(f_out, ¨&leq;¨); break;/*less than or equal to*/
   case ´\xf4´: write_s(f_out, ¨&Integral;¨); break;/*top half integral*/
   case ´\xf5´: write_s(f_out, ¨&Integral;¨); break;/*lower half integral*/
   case ´\xf6´: write_s(f_out, ¨&divide;¨); break;/*divide by*/
   case ´\xf7´: write_s(f_out, ¨&approx;¨); break;/*approximately*/
   case ´\xf8´: write_s(f_out, ¨&deg;¨); break;/*degree sign*/
   case ´\xf9´: write_s(f_out, ¨[filled_deg]¨); break;
                                         /*filled in degree sign*/
   case ´\xfa´: write_s(f_out, ¨&squf;¨); break;/*small bullet*/
   case ´\xfb´: write_s(f_out, ¨[sqrt]¨); break;/*square root*/
   case ´\xfc´: write_s(f_out, ¨[sup n]¨); break;/*superscript n*/
   case ´\xfd´: write_s(f_out, ¨&sup2;¨); break;/*superscript 2*/
   case ´\xfe´: write_s(f_out, ¨[small box]¨); break;/*small box*/
   case ´\xff´: write_s(f_out, ¨ ¨); break;/*phantom space*/
   default:
   { 
    if(isprint(c))send_char_to_html(f_out, c);
    else write_hex_code(f_out, c);
    break;
   }
  }
}
/*
   Converts extended PC bytecodes into HTML aliased characters.
     While the HTML alias character set is quite large, 
      it is not entirely a superset of the PC byescodes, 
        and I have been forced to take some liberties. 
   Sources:
    Thom Hogan, The Programmer´s PC Sourcebook, Microsoft Press, 1988, 
       Table 1.22, IBM ASCII Character Set
    Character Entity Table,
      https://dev.w3.org/html5/html-author.charref
*/
/*-------------------------------------------------------------*/

int parse_symetric_sequence(
                         int f_out, 
                         unsigned char input_bufer[], 
                         int index_to_first_byte_in_sequence
                       )
{
  int index_to_last_byte in_sequence;
  unsigned chr opcode;

  if( 
      index_to_last_byte in_sequence=
        symetric_sequence_is_valid(input_bufer, index_to_buffer) 
      == 
     -1)
     {
       write_s(f_out, ¨[hex code 1d]¨);
       return(index_to_first_byte_in_sequence);
     }
  else
  {
    opcode = input_bufer[index_to_buffer+3];
    switch (opcode)
    {
      case ´\x03´:
      case ´\x04´:
      case ´\x05´:   
      case ´\x06´: 
        {
          /* save and reset toggles and flags */
          bytes_added_to_stream=
             parse_note( 
                         f_out, 
                         input_bufer, 
                         index_to_first_byte_in_sequence
                         index_to_last_byte_in_sequence
                       );
         return(
                 index_to_last_byte_in_sequence
                   -bytes_added_to_stream);
         break;
       }     
/*
     HTML (null-terminated C string) 
        embedded in Wordstar format by function parse_note
*/
      case ´\xff´ :
      {
         /*restore toggles and flags */
         /*output the contents of the sequence verbatim*/
         return(index_to_last_byte_in_sequence); 
         break;
      }
/*
    Converts Wordstar image file tag into HTML image file tag
*/
      case ´\x10´ :
      {
        return(index_to_last_byte_in_sequence);
        break;
      }
/*
    Header
*/
      case ´\x00´  :
      {
        return(index_to_last_byte_in_sequence);
        break;
      }
/*
    Color
*/
      case ´\x01´  :
      {
        return(index_to_last_byte_in_sequence);
        break;
      }
/*
     Font
*/
      case ´\x02´  :
      {
        return(index_to_last_byte_in_sequence);
        break;
      }
/*
   Tabs and Dot Leaders
*/
      case ´\x09´  :
      {
        return(index_to_last_byte_in_sequence);
        break;
      }
/*
    End of Page-- Wordstar reccomends ignoring this
*/
      case ´\x0b´  :
      {
        return(index_to_last_byte_in_sequence);
        break;
      }
/*
    Page Offset-- Wordstar says this should not occur in files, 
       only in printer drivers
*/
      case ´\x0c´  :
      {
        return(index_to_last_byte_in_sequence);
        break;
      }
/*
     Paragraph Number
*/
      case ´\x0d´  :
      {
        return(index_to_last_byte_in_sequence);
        break;
      }
/*
    Index Item  
*/
      case ´\x0e´  :
      {
        return(index_to_last_byte_in_sequence);
        break;
      }
/*
     User Print Control
*/
      case ´\x0f´  :
      {
        return(index_to_last_byte_in_sequence);
        break;
      }
/*
    Paragraph Style
*/
      case ´\x11´  :
      {
        return(index_to_last_byte_in_sequence);
        break;
      }
/*
    Alternate/Normal Font Change
*/
      case ´\x15´  :
      {
        return(index_to_last_byte_in_sequence);
        break;
      }
/*
   Truncation
*/
      case ´\x16´  :
      {
        return(index_to_last_byte_in_sequence);
        break;
      }
/*
*/
      default:
      {
        return(index_to_last_byte_in_sequence);
        break;
      }

    } /* end switch */
  } 
}
/*
   returns index of last byte which is still in the buffer, 
    and has been processfd, so normal incrementing of the index 
     by the for-loopwill get one to a new byte,
*/
/*------------------------------------------------------------*/
 int parse_note(
                int f_out, 
                unsigned char input_bufer[], 
                int index_to_first_byte_in_sequence,
                int index_to_last_byte_in_sequence
           );
{
}
 
/* 
   returns the number of bytes inserted
   each note will be converted to sn ¨aside,¨ ¨<aside>¨, and ¨</aside>¨
*/
/*-------------------------------------------------------------*/

int symetric_sequence_is_valid(
                                unsigned char input_bufer[], 
                                int index_to_first_byte_in_sequence
                              )
{
  unsigned char high_byte_of_offset, low_byte_of_offset;
  int offset, index_to_last_byte in_sequence;

  high_byte_of_offset=
       input_bufer[index_to_first_byte_in_sequence+2];
  low_byte_of_offset=
       input_bufer[index_to_first_byte_in_sequence+1];
  offset = 
      (int)low_byte_of_offset + (256 * (int) high_byte_of_offset  );
  index_to_last_byte in_sequence=
       index_to_first_byte_in_sequence+offset+2;
  if(
      (input_bufer[index_to_first_byte_in_sequence] == '\x1d' )
     &&
      (input_bufer[index_to_last_byte in_sequence] == '\x1d' ) 
     &&
      (
        input_bufer[index_to_last_byte in_sequence-1] 
       ==  
        high_byte_of_offset
      )
     &&
      (
        input_bufer[index_to_last_byte in_sequence-2] 
       ==  
        low_byte_of_offset
      )
      &&
      (
        offset > 0
      )
    )return(index_to_last_byte in_sequence);
    else return(-1);
}
/*returns index of terminating [Hex 1D] if valid, else -1*/
/*-------------------------------------------------------------*/



  

